# Routemaster is designed to be given any PORO
# NB. must implement id method to use 'show' route
# and generate a restful route to the resource
#
# Author::    Ryan Kendall (mailto:ryankendallt@gmail.com)
# Copyright:: Copyright (c) 2013 Ryan Kendall
# License::   MIT
#
class RouteMaster

  # Creates methods which return a string representation
  # of the URL route to an object
  # The object must respond to 'id' if you wish to use show
  [
    :create, 
    :update, 
    :delete, 
    :show, 
    :index  
  ].each do |rest|
    define_method(rest) do |model|
      "#{model.class.name.downcase}/" + 
        (rest==:show||rest==:delete ? "#{model.id}/#{rest}" : rest.to_s)
    end
  end
end